Subject: Re: [PATCH] diagnose.c: refactor to safely use 'd_type'

From: Junio C Hamano <[email-masked]>
Date: Sun, 18 Sep 2022 18:13:34 -0700

"Victoria Dye via GitGitGadget" <[email-masked]> writes:

> From: Victoria Dye <[email-masked]>
>
> Refactor usage of the 'd_type' property of 'struct dirent' in 'diagnose.c'
> to instead utilize the compatibility macro 'DTYPE()'. On systems where
> 'd_type' is not present in 'struct dirent', this macro will always return
> 'DT_UNKNOWN'. In that case, instead fall back on using the 'stat.st_mode' to
> determine whether the dirent points to a dir, file, or link.
>
> Additionally, add a test to 't0092-diagnose.sh' to verify that files (e.g.,
> loose objects) are counted properly.
>
> Note that the new function 'get_dtype()' is based on 'resolve_dtype()' in
> 'dir.c' (which itself was refactored from a prior 'get_dtype()' in
> ad6f2157f9 (dir: restructure in a way to avoid passing around a struct
> dirent, 2020-01-16)), but differs in that it is meant for use on arbitrary
> files, such as those inside the '.git' dir. Because of this, it does not
> search the index for a matching entry to derive the 'd_type'.
>
> Reported-by: Randall S. Becker <[email-masked]>
> Signed-off-by: Victoria Dye <[email-masked]>
> ---

Beautiful.  Use of DTYPE() macro that already hides the platform
specifics, and get_dtype() implementation that calls lstat() lazily,
are exactly the solution I was expecting to see.

Nicely done.  Will queue.  Thanks.